package org.example.lc.service;

import org.example.lc.request.AddUserReq;
import org.example.lc.response.ResponseBean;
import org.ldaptive.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

@Service
public class LdapService {
    @Value("${ldap.base-dn}")
    private String baseDn;

    @Autowired
    private ConnectionFactory connectionFactory;

    public SearchResult search(String filter) throws LdapException {
        Connection conn = connectionFactory.getConnection();
        try {
            conn.open();

            SearchOperation search = new SearchOperation(conn);
            SearchResult result = search.execute(
                    new SearchRequest(
                            baseDn, "(cn=*)")).getResult();

            for (LdapEntry entry : result.getEntries()) {
                // do something useful with the entry
                System.out.println(entry.getDn());
                entry.getAttributes();

            }

        } finally {
            conn.close();
        }
        return null;
    }

    public ResponseBean<Boolean> addUser(AddUserReq req) throws LdapException {
        LdapEntry entry = new LdapEntry(
                "cn=" + req.getUserName() + ",cn=readers,ou=users,dc=northking,dc=net",
                new LdapAttribute("userName", req.getUserName()),
                new LdapAttribute("pwd", req.getPwd()),
                new LdapAttribute("email", req.getEmail()));

        Connection conn = connectionFactory.getConnection();
        try {
            conn.open();
            AddOperation add = new AddOperation(conn);
            add.execute(new AddRequest(entry.getDn(), entry.getAttributes()));
        } finally {
            conn.close();
        }
        return null;
    }
}